﻿// $Header: $ 
// Copyright (c) CODE Consulting and Development, s.r.o., Plzen. All rights reserved.

using System.Diagnostics;
using HmiScreen.Properties;
using JetBrains.Annotations;
using OpcLabs.EasyOpc.DataAccess;
using System;
using System.Collections.Generic;
using System.Windows.Forms;
using OpcLabs.EasyOpc.DataAccess.OperationModel;

namespace HmiScreen
{
    public partial class Form1 : Form
    {
        // ReSharper disable once NotNullMemberIsNotInitialized
        public Form1()
        {
            InitializeComponent();
        }

        // ReSharper disable InconsistentNaming
        private void Form1_Load(object sender, EventArgs e)
        // ReSharper restore InconsistentNaming
        {
            var argumentsList = new List<DAItemGroupArguments>();
            // ReSharper disable LoopCanBeConvertedToQuery
            foreach (Control control in Controls)
            // ReSharper restore LoopCanBeConvertedToQuery
            {
                Debug.Assert(control != null);

                var itemId = control.Tag as string;
                if (itemId != null)
                    argumentsList.Add(new DAItemGroupArguments("", "OPCLabs.KitServer.2", itemId, 50, control));
            }
            easyDAClient1.SubscribeMultipleItems(argumentsList.ToArray());
        }

        // ReSharper disable InconsistentNaming
        private void easyDAClient1_ItemChanged([NotNull] object sender, [NotNull] EasyDAItemChangedEventArgs e)
        // ReSharper restore InconsistentNaming
        {
            var textBox = e.Arguments.State as TextBox;
            if (textBox != null && textBox.ReadOnly)
            {
                // ReSharper disable ConvertIfStatementToConditionalTernaryExpression
                if (e.Exception == null)
                // ReSharper restore ConvertIfStatementToConditionalTernaryExpression
                {
                    Debug.Assert(e.Vtq != null);
                    textBox.Text = e.Vtq.DisplayValue();
                }
                else
                    textBox.Text = Resources.Form1_easyDAClient1_ItemChanged____Error___;
            }
        }

        // ReSharper disable InconsistentNaming
        private void writeButton_Click(object sender, EventArgs e)
        // ReSharper restore InconsistentNaming
        {
            TextBox textBox = writeValueTextBox;
            var itemId = (string) textBox.Tag;
            Debug.Assert(itemId != null);

            easyDAClient1.WriteItemValue("", "OPCLabs.KitServer.2", itemId, textBox.Text);
        }
    }
}
